//WebFlow Project, Leader Tom Haupt
//Farhad Mamedbekov, Summer 99

//Applet for Administrator Page, implemented with the swing components
//Requires Swing set.  For Netscape, it is envisage 
// to have the swing on the client machine
//Starts, Terminates, or Checks the status of the WebFlow server


import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import java.io.*;

//for Stack class
import java.util.*;

//for SWING set interface
import javax.swing.*;


public class adminappl2 extends JApplet 
                         implements ActionListener {

  //cariables that are extracted from the envoking HTML
  //allows changing configuration by changing HTML PARAM only
  private String Display;
  private String ConfFile;
  private String IorFile;
  private String MyClassPath;
  private String servletURL;
  private String HashTableFile;
   
  //inerface elements
  private CardLayout cl = new CardLayout();
  String status = new String();
  protected JProgressBar progressBar;
  protected JPanel norhtPanel;
  private JTextArea logText;  //Action Log
  private JLabel  statusLabel = new JLabel ("Lookig for the server...");
  private JLabel  logTitle    = new JLabel ("Your action log is here:");


  //Action buttons, their command, labels, and a command stack
  final int ButtonNum = 6;
  protected JButton jb[];
  String Buttons[] = {"Turn Server ON", "Turn Server OFF", "Test Server Status", "Configuration", "Help" , "Reload HashTable"};
  private Stack stack = new Stack();

  //Keywords passed to the servlet
  String command[]={"start","kill","ping","conf","help", "SystemConf"};
  //Keywords passed by the servlet
  String KWord[]={"Object is active","Object is NOT ACTIVE", "Error", "conf", "help", "SystemConf"};


  //Prompts printed for user
  String stateWord[]={"Server Status: SERVER IS ON", "Server Status: SERVER IS OFF", "Check the log file for problem and ping the server later"};
  private Color color[] = { Color.green,  Color.red, Color.yellow };
  private int ActionCount = 0;
 
  //two helper classes
  private Timer timer;
  private LongTask task = new LongTask(1);
  int attempts[] = {50, 5, 1, 1, 1, 1};
  public final static int ONE_SECOND = 1000; 
  public final static int TIMER_LENGTH=100;

///////////////////////////////////////////////////////////////  
//                Function Declaration
///////////////////////////////////////////////////////////////

  public String sameOrBlank(String s)
  {
     if (s==null)
       return "";
     return s;
  }


  public String setParameters()
  {
    Display = sameOrBlank(getParameter("display"));  
    ConfFile = sameOrBlank(getParameter("MasterConfFile"));
    IorFile  = sameOrBlank(getParameter("MasterIorFile"));
    MyClassPath = sameOrBlank(getParameter("ClassPath"));
    servletURL = sameOrBlank(getParameter("servletURL"));
    HashTableFile = sameOrBlank(getParameter("HashTableFile"));   

    return  servletURL+"?MasterConfFile="+ConfFile+"&MasterIorFile="+IorFile+"&ClassPath="+MyClassPath+"&display="+Display+ "&HashTableFile="+ HashTableFile + "&command=";
  } 

//draws the user interface and sets up the timer
  public void init() { 
    servletURL = setParameters();
    
    getContentPane().setLayout( new BorderLayout()); 

    //initialize North Panel consisting of interchangeble status
    statusLabel=new JLabel("Checking server status...");
    statusLabel.setVerticalTextPosition(JLabel.CENTER);
    statusLabel.setHorizontalAlignment(JLabel.CENTER);

    progressBar = new JProgressBar(0, TIMER_LENGTH);
    progressBar.setValue(3);
    progressBar.setStringPainted(true);   

    norhtPanel = new JPanel();
    norhtPanel.setLayout(cl);
    norhtPanel.add("text", statusLabel);
    norhtPanel.add("bar",  progressBar);
    getContentPane().add(norhtPanel, BorderLayout.NORTH);

    //setting the central Control Panel consisting of ButtonNum buttons
    JPanel controlPanel = new JPanel();
    controlPanel.setLayout(new GridLayout(ButtonNum,1));

    jb = new JButton [ButtonNum];
    for (int i = 0 ; i<ButtonNum; i++)
    {
      jb[i] = new JButton(Buttons[i]);
      jb[i].setActionCommand(Buttons[i]);
      jb[i].setVerticalTextPosition(AbstractButton.CENTER);
      jb[i].setHorizontalTextPosition(AbstractButton.LEFT);
      jb[i].addActionListener(this);
      controlPanel.add(jb[i]);
    }
   
    //setting the South Control Panel consisting of text area and a lable
    JPanel southPanel=new JPanel(); 
    southPanel.setLayout(new BorderLayout());
    southPanel.add(controlPanel, BorderLayout.WEST);

    logText = new JTextArea ("Checking the server existance", 20, 20);    
    logText.setEditable(false);
    JScrollPane scrollPane = new JScrollPane(logText,
                                   JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
                                   JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    southPanel.add(scrollPane, BorderLayout.CENTER);
    getContentPane(). add(southPanel, BorderLayout.CENTER);


    //set up the timer
    timer = new Timer(ONE_SECOND, new ActionListener() {
            public void actionPerformed(ActionEvent evt) 
            {
                task.go();            
                if (task.done())
                {
                    Toolkit.getDefaultToolkit().beep();
                    timer.stop();
                    setScreen(task.getMessage(), "text", 0);

                    //if there are no more actions in the sack, return control
                    //otherwise implement actions
                    if (stack.empty()) {
                        setControls(true);
                    }
                    else {
                      Integer tmp = (Integer) stack.pop();
                      int j = tmp.intValue();
                      startTask(j);
                    } 
                }
                else 
		{
                   int IProg=TIMER_LENGTH * task.getCurrent() / task.getLengthOfTask();
                   //String Sout = task.getMessage();
                   setScreen("", "bar",IProg );
		}  //else
            }
    });  //end of timer

    //check the initial server state
    startTask(2);
    }   //init

  //checks which cutton is pressed and sets the corresponding task parameters
  //runs the timer to execute the task
  public void actionPerformed(ActionEvent e) 
  {
    for (int i=0; i<ButtonNum; i++)
        if (e.getActionCommand().equals(Buttons[i]))
	{
           setControls(false);

           //check if we start the server, request several actions via stack
           if (i==0) {
             stack.push(new Integer(3));   //print configuration
             stack.push(new Integer(5));   //add hashtable
           }

           //set the task parameters and start the timer
           startTask(i);         
        }  //if
  }    //actionPerformed


  //sets the parameters for jth task and starts the timer
  public void startTask(int j) {
    task.setTask(servletURL+command[j],servletURL+command[2], KWord[j], attempts[j]);
     timer.start();
  } 
  
  public void setScreen(String MSG, String CRD, int STBarLen)
  {
    //set the progressbar value
    progressBar.setValue(STBarLen);      

    //get the server status based on the incoming text and show the status
    int state = getState(MSG);
    statusLabel.setText(stateWord[state]); 
    statusLabel.setForeground(color[state]);
   
    // but show either progressbar or status text
    cl.show(norhtPanel, CRD);
  
    //update the log screen, if end of the action
    if (MSG.length()>0)
      logText.append("\n----Action# " + (++ActionCount) + "----\n" + MSG);
  }


  //returns server status based on the message passed
  public int getState(String MSG)
  {
    if  (-1<MSG.indexOf(KWord[0])) return 0;    
    if  (-1<MSG.indexOf(KWord[1])) return 1;     
    else return 2;
  }

  //Enables or disables user contrlos so that the user does not run multiple threads
  public void setControls(boolean bstate)
  {  
    for (int i=0; i<ButtonNum; i++)
      jb[i].setEnabled(bstate);
  }     
}


//Implements communication with servlet
//Does not know anything about interface

class LongTask
{
  static int counter;      //times attempted to run the task
  static int tasklength;   //maximum numer to run the tast
  static String lastMSG;   //last mesage from the servlet
  static String SURL;      //URL to be executed the first time
  static String CURL;      //URL to be executed from the second time on
  static String TermMSG;   //mesage from the servlet that stops execution
  static boolean done;     //done?

  //constructor
  public LongTask(int _tasklength) //, int _counter)
  {
    tasklength=_tasklength;
    counter=0;
    tasklength=10; //_counter;
    done=true;
  }

  //return internal variables
  public boolean done() { return done;}
  public String getSURL() {return SURL;}
  public int getCurrent() {return counter;}
  public int getLengthOfTask() { return tasklength;}
  public String getMessage() { return lastMSG;}

  //sets up the task parameters before each execution
  public void setTask(String _SURL, String _CURL, String _TermMSG, int _tasklength)
  {
     SURL=_SURL;
     CURL=_CURL;
     TermMSG=_TermMSG;
     tasklength=_tasklength;
     done=false;
     counter=0;
  }

  //contains actions implemented at each call of the task
  //reads URL, stops if the message is right or enoght attempts
  public void go()
  {
    if (!done)
    {
      if (counter == 0)
         lastMSG = ReadServlet(SURL);
      else 
         lastMSG = ReadServlet(CURL); 

      counter++;
      if ((counter==tasklength) || (-1<lastMSG.indexOf(TermMSG)))
           done=true;
    }
  }

  //reads text from servlet with the given URL
  public String ReadServlet(String sURL)
  {
    String fromServlet="";
    String LineIn="";

    try {
      java.net.URL url = new java.net.URL(sURL);
      InputStream istream;

      try {
        istream = url.openStream();
        BufferedReader in = new BufferedReader(new InputStreamReader(istream));
        
        while ( (LineIn=in.readLine()) !=null) 
           fromServlet +=LineIn + "\n";
	//String ref = in.readLine();
        istream.close();
        return fromServlet;
      }
      catch(Exception e) {
        System.err.println("Error " + e +" while reading from: " + sURL);
        return "Error " + e + " while reading from: " + sURL;
      }
    }  //outer try
    catch(Exception e) {
      System.err.println("Can't open URL: " + sURL);
      return "Can't open URL: " + sURL;
    }
  }  //function

}


